#! /usr/bin/python

from gi.repository import Gtk, Gdk
import gettext
import os
import dbus
import fcntl
import sys
import time

from xml.dom.minidom import parse
import xml.dom.minidom
#print "-----------------------------"
INTERNAL_ICON	= "/usr/lib/cdos-airplane-mode/icons/airplane_mode_off.png"
gettext.install("cdos-desktop", "/usr/share/cdos-de/locale")
RESOLUTION_FILE = os.environ['HOME'] + "/.config/monitors.xml"
CONFIG_FILE = os.environ['HOME'] + "/.config/airplanemode.config"
BLUE_CONFIG_FILE = "/usr/lib/cdos-airplane-mode/airplanemode_blue.config"


WIFI_ICON_ON = "/usr/lib/cdos-airplane-mode/icons/wifi_on.png"
WIFI_ICON_OFF = "/usr/lib/cdos-airplane-mode/icons/wifi_off.png"
WIFI_ICON_SELECT_ON = "/usr/lib/cdos-airplane-mode/icons/wifi_on_set.png"
WIFI_ICON_SELECT_OFF = "/usr/lib/cdos-airplane-mode/icons/wifi_off_set.png"

BLUE_ICON_ON = "/usr/lib/cdos-airplane-mode/icons/bt_on.png"
BLUE_ICON_OFF = "/usr/lib/cdos-airplane-mode/icons/bt_off.png"
BLUE_ICON_SELECT_ON = "/usr/lib/cdos-airplane-mode/icons/bt_on_set.png"
BLUE_ICON_SELECT_OFF = "/usr/lib/cdos-airplane-mode/icons/bt_off_set.png"


def update_config(str):
	fcon = open(CONFIG_FILE, "w")
	fcon.write(str)
	fcon.close()

def update_blue_config(str):
	fcon = open(CONFIG_FILE, "w")
	fcon.write(str)
	fcon.close()

def read_config():
	if os.path.exists(CONFIG_FILE) == False:
		#print "first use"
		os.popen("touch " + CONFIG_FILE)
		os.popen("chmod 777 " + CONFIG_FILE)
		return "1"
	fcon = open(CONFIG_FILE, "r")
	return fcon.read().strip('\n')

def read_blue_config():
	if os.path.exists(CONFIG_FILE) == False:
		#print "first use blue"
		os.popen("touch " + CONFIG_FILE)
		os.popen("chmod 777 " + CONFIG_FILE)
		return "1"
	fcon = open(CONFIG_FILE, "r")
	return fcon.read().strip('\n')


def get_wifi_status():
	output = os.popen('rfkill list wifi')
	info = output.read()
	if info.find("Soft blocked: no") != -1:
		#print "0 : ",info.find("Soft blocked: no");
		if info.find("Hard blocked: no"):
			return True
		else:
			return False
	elif info.find("Soft blocked: yes") != -1:
		return False
	else:
		return False
def get_blue_status():
	output = os.popen('rfkill list bluetooth')
	info = output.read()
	if info.find("Soft blocked: no") != -1:
		#print "0 : ",info.find("Soft blocked: no");
		if info.find("Hard blocked: no"):
			return True
		else:
			return False
	elif info.find("Soft blocked: yes") != -1:
		return False
	else:
		return False


#status = get_wlan_status()




class CMSWindow(Gtk.Window):
	def __init__(self):
		Gtk.Window.__init__(self, title=_("Cinnamon Multi-Monitor Switcher"))
		self.WIFI_ICON = WIFI_ICON_ON
		self.BLUE_ICON = BLUE_ICON_ON
		self.WIFI_SELECT_ICON = WIFI_ICON_SELECT_ON
		self.BLUE_SELECT_ICON = BLUE_ICON_SELECT_ON


		self.status_wifi = get_wifi_status()
		self.status_blue = get_blue_status()
		if self.status_wifi == True:
			self.WIFI_ICON	= WIFI_ICON_ON
			self.WIFI_SELECT_ICON = WIFI_ICON_SELECT_ON
		else:
			self.WIFI_ICON	= WIFI_ICON_OFF
			self.WIFI_SELECT_ICON = WIFI_ICON_SELECT_OFF

		if self.status_blue == True:
			self.BULE_ICON	= BLUE_ICON_ON
			self.BLUE_SELECT_ICON = BLUE_ICON_SELECT_ON
		else:
			self.BLUE_ICON	= BLUE_ICON_OFF
			self.BLUE_SELECT_ICON = BLUE_ICON_SELECT_OFF

			
# Main window conf
		self.set_border_width(6)
		self.set_position(Gtk.WindowPosition.CENTER)
		self.set_default_size(350, 270)
		self.set_resizable(False)
		self.set_decorated(False)
		self.set_opacity(1.0)
		self.set_icon_name("backgrounds")
#		self.modify_base(Gtk.STATE_NORMAL, Gtk.gdk.color_parse("#DCDCDC")) 

# drawing GUI stuff
		hbox = Gtk.Box(spacing=6)
		self.add(hbox)

# wifi button
		self.i_button = Gtk.Button()
		self.i_button.connect("clicked", self.on_wifi_button_clicked)
		self.i_image = Gtk.Image()
                self.i_image.set_from_file(self.WIFI_SELECT_ICON)
		self.i_button.add(self.i_image)
		hbox.pack_start(self.i_button, True, True, 0)

		self.connect("key_press_event", self.key_press_event)
# blue button
		self.m_button = Gtk.Button()
		self.m_button.connect("clicked", self.on_blue_button_clicked)
		self.m_image = Gtk.Image()
                self.m_image.set_from_file(self.BLUE_ICON)
		self.m_button.add(self.m_image)
		hbox.pack_start(self.m_button, True, True, 0)
		self.connect("key_press_event", self.key_press_event)

	
			

	def on_wifi_button_clicked(self, widget):
		if self.status_wifi == True:
			os.popen('nmcli nm wifi off')
			os.popen('rfkill block wifi')
			self.status_wifi = False
			self.WIFI_ICON	= WIFI_ICON_OFF
			self.WIFI_SELECT_ICON = WIFI_ICON_SELECT_OFF
			#print "wifi close !!!!!!!!!!!!"
		else:
			os.popen('rfkill unblock wifi')
			os.popen('nmcli nm wifi on')
			self.status_wifi = True
			self.WIFI_ICON	= WIFI_ICON_ON
			self.WIFI_SELECT_ICON = WIFI_ICON_SELECT_ON
			#print "wifi open !!!!!!!!!!!!!"
		self.i_image.set_from_file(self.WIFI_SELECT_ICON)
		self.m_image.set_from_file(self.BLUE_ICON)
	

	def on_blue_button_clicked(self, widget):
		if self.status_blue == True:
			os.popen('rfkill block bluetooth')
			#os.popen('nmcli nm bluetooth off')
			self.status_blue = False
			self.BLUE_ICON	= BLUE_ICON_OFF
			self.BLUE_SELECT_ICON = BLUE_ICON_SELECT_OFF
			update_blue_config("off")
			#print "blue close !!!!!!!!!!"
		else:
			os.popen('rfkill unblock bluetooth')
                        time.sleep(1)
                        os.popen('rfkill block bluetooth')
		        time.sleep(1)
                        os.popen('rfkill unblock bluetooth')
                        #os.popen('nmcli nm bluetooth on')
			self.status_blue = True
			self.BLUE_ICON	= BLUE_ICON_ON
			self.BLUE_SELECT_ICON = BLUE_ICON_SELECT_ON
			update_blue_config("on")
			#print "blue open !!!!!!!!!!!!!"
		self.m_image.set_from_file(self.BLUE_SELECT_ICON)
		self.i_image.set_from_file(self.WIFI_ICON)





	def key_press_event(self, widget, event):
		global timer_interval
		timer_interval=0
		keyname = Gdk.keyval_name(event.keyval)
		#print "Key %s (%d) was pressed" % (keyname, event.keyval)
		if(keyname == "Escape"):
			Gtk.main_quit()
		if((keyname =="p") or (keyname =="F10")):
			if(self.i_button==self.get_focus()):
				self.set_focus(self.m_button)
				childimage = self.m_button.get_child()
				childimage.set_from_file(GRAY_MIRRORED_ICON)
				childimage = self.i_button.get_child()
				childimage.set_from_file(INTERNAL_ICON)
			elif(self.m_button==self.get_focus()):
				self.set_focus(self.d_button)
				childimage = self.d_button.get_child()
				childimage.set_from_file(GRAY_DOCKED_ICON)
				childimage = self.m_button.get_child()
				childimage.set_from_file(MIRRORED_ICON)
			elif(self.d_button==self.get_focus()):
				self.set_focus(self.e_button)
				childimage = self.e_button.get_child()
				childimage.set_from_file(GRAY_EXTENDED_ICON)
				childimage = self.d_button.get_child()
				childimage.set_from_file(DOCKED_ICON)
			elif(self.e_button==self.get_focus()):
				self.set_focus(self.i_button)
				childimage = self.i_button.get_child()
				childimage.set_from_file(GRAY_INTERNAL_ICON)
				childimage = self.e_button.get_child()
				childimage.set_from_file(EXTENDED_ICON)
		elif(keyname=="Right"):		
			if(self.i_button==self.get_focus()):
				# BLUE SELECT
				childimage = self.m_button.get_child()
				childimage.set_from_file(self.BLUE_SELECT_ICON)
				childimage = self.i_button.get_child()
				childimage.set_from_file(self.WIFI_ICON)
			elif(self.m_button==self.get_focus()):
				childimage = self.m_button.get_child()
				childimage.set_from_file(self.BLUE_SELECT_ICON)

		elif(keyname=="Left"):
			if(self.i_button==self.get_focus()):
				childimage = self.i_button.get_child()
				childimage.set_from_file(self.WIFI_SELECT_ICON)
			elif(self.m_button==self.get_focus()):
				# WIFI SELECT
				childimage = self.i_button.get_child()
				childimage.set_from_file(self.WIFI_SELECT_ICON)
				childimage = self.m_button.get_child()
				childimage.set_from_file(self.BLUE_ICON)




win = CMSWindow()
win.connect("delete-event", Gtk.main_quit)
win.connect("focus-out-event", Gtk.main_quit)

if( len(sys.argv) > 1):
	mode=sys.argv[1]
	#print mode
	if (mode == "1"):
		win.do_switch_internal()
	elif (mode == "2"):
		win.do_switch_mirror()
	elif (mode == "3"):
		win.do_switch_docked()
	elif (mode == "4"):
		win.do_switch_extended()
else:
	#print "no args ..."
	win.show_all()
	Gtk.main()
