#!/usr/bin/env python

from SettingsWidgets import *
from gi.repository import Gio

class Module:
    def __init__(self, content_box):
        keywords = _("desktop, home, button, trash")
        sidePage = SidePage(_("Desktop"), "cs-desktop1", keywords, content_box, module=self)
        self.sidePage = sidePage
        self.name = "desktop"
        self.category = "prefs"
        self.comment = _("Manage your desktop icons")

    def _loadCheck(self):
        if 'org.nemo' in Gio.Settings.list_schemas():            
            return True
        else:
            return False

    def on_module_selected(self):
        if not self.loaded:
            print "Loading Desktop module"
            nemo_desktop_schema = Gio.Settings.new("org.nemo.desktop")
            nemo_desktop_keys = nemo_desktop_schema.list_keys()

            bg = SectionBg()        
            self.sidePage.add_widget(bg)
            vbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)#VERTICAL
            bg.add(vbox)
            vbox1 = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
            vbox2 = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
            vbox.pack_start(vbox1,True,True,0)
            vbox.pack_start(vbox2,True,True,0)

            section = Section(_("Desktop layout"))
            # self.face_button = Gtk.Button()
            # self.face_image = Gtk.Image()
            # self.face_button.set_sensitive(False)
            # self.face_button.set_image(self.face_image)
            # self.face_image.set_from_file("/usr/lib/cdos-settings/CPIcons/desktop-Item.png")
            # self.face_button.set_alignment(0.0, 0.5)
            # self.face_button.set_relief(Gtk.ReliefStyle.NONE)
            # section.add(self.face_button)
            self.face_box = vbox2 = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)
            self.face_image = Gtk.Image()
            self.face_image.set_from_file("/usr/lib/cdos-settings/CPIcons/desktop-Item.png")
            self.face_box.pack_start(self.face_image, True, True, 50)
            section.add(self.face_box)
            #vbox.add(section)
            vbox1.pack_end(section,False,False,0)

            section = Section(_("Desktop Icons"))            
            label = Gtk.Label()
            label.set_markup("<small>%s</small>" % _("Select the items you want to see on the desktop:"))
            label.get_style_context().add_class("dim-label")
            section.add(label)
            if "computer-icon-visible" in nemo_desktop_keys:
                section.add(GSettingsCheckButton(_("Computer"), "org.nemo.desktop", "computer-icon-visible", None))
            if "home-icon-visible" in nemo_desktop_keys:
                section.add(GSettingsCheckButton(_("Home"), "org.nemo.desktop", "home-icon-visible", None))
            if "trash-icon-visible" in nemo_desktop_keys:
                section.add(GSettingsCheckButton(_("Trash"), "org.nemo.desktop", "trash-icon-visible", None))
            if "volumes-visible" in nemo_desktop_keys:
                section.add(GSettingsCheckButton(_("Mounted volumes"), "org.nemo.desktop", "volumes-visible", None))
            if "network-icon-visible" in nemo_desktop_keys:
                section.add(GSettingsCheckButton(_("Network"), "org.nemo.desktop", "network-icon-visible", None))
            #vbox.add(section)
            vbox2.pack_start(section,False,False,0)
