#!/usr/bin/env python

from SettingsWidgets import *
from gi.repository import Gtk


class Module:
    def __init__(self, content_box):
        keywords = _("font, size, small, large")
        sidePage = SidePage(_("Fonts"), "cs-fonts1", keywords, content_box, module=self)
        self.sidePage = sidePage
        self.name = "fonts"
        self.category = "appear"
        self.comment = _("Configure system fonts")
        self.widget1 = self.widget2 = self.widget3 = None
        self.widget4 = self.widget5 = None        

    def on_module_selected(self):
        if not self.loaded:
            print "Loading Fonts module"
            bg = SectionBg()        
            self.sidePage.add_widget(bg)
            vbox = Gtk.Box(orientation=Gtk.Orientation.VERTICAL)#VERTICAL->HORIZONTAL
            bg.add(vbox)

#	    section = Section(_(""))
#	    self.face_button = Gtk.Button()
#            self.face_image = Gtk.Image()  
#	    self.face_button.set_sensitive(False)
#            self.face_button.set_image(self.face_image)
#            self.face_image.set_from_file("/usr/lib/cdos-settings/CPIcons/font-option.png")  
#            self.face_button.set_alignment(0.0, 0.5)
#	    self.face_button.set_relief(Gtk.ReliefStyle.NONE)
#	    section.add(self.face_button)
#	    vbox.add(section)
            
            section = Section(_("Font Selection"))
	    section = Section(_("Font Selection and Settings"))
            section.add(self.make_combo_group(GSettingsFontButton, _("Default font"), "org.cdos.desktop.interface", "font-name", None))
            #section.add(self.make_combo_group(GSettingsFontButton, _("Document font"), "org.gnome.desktop.interface", "document-font-name", None))
            section.add(self.make_combo_group(GSettingsFontButton, _("Monospace font"), "org.gnome.desktop.interface", "monospace-font-name", None))
            section.add(self.make_combo_group(GSettingsFontButton, _("Window title font"), "org.cdos.desktop.wm.preferences", "titlebar-font", None))
            vbox.add(section)
            
            vbox.add(Gtk.Separator.new(Gtk.Orientation.HORIZONTAL))

            section = Section(_("Font Settings"))
            aa_options = [["none", _("None")], ["grayscale", _("Grayscale")], ["rgba", _("Rgba")]]
            hinting_options = [["none", _("None")], ["slight", _("Slight")], ["medium", _("Medium")], ["full", _("Full")]]
           # section.add(self.make_combo_group(GSettingsRangeSpin, _("Text scaling factor"), "org.cdos.desktop.interface", "text-scaling-factor", None))
            section.add(self.make_combo_group(GSettingsComboBox, _("Antialiasing"), "org.cdos.settings-daemon.plugins.xsettings", "antialiasing", aa_options))
            section.add(self.make_combo_group(GSettingsComboBox, _("Hinting"), "org.cdos.settings-daemon.plugins.xsettings", "hinting", hinting_options))
            vbox.add(section)
            vbox.pack_start(self.restore_button(), True, True, 0)

    def make_combo_group(self, widget, group_label, root, key, stuff):
        self.size_groups = getattr(self, "size_groups", [Gtk.SizeGroup.new(Gtk.SizeGroupMode.HORIZONTAL) for x in range(2)])
        
        box = IndentedHBox()
        label = Gtk.Label()
        label.set_markup(group_label)
        label.props.xalign = 0.0
        self.size_groups[0].add_widget(label)
        box.pack_start(label, False, False, 0)

        if (key == "text-scaling-factor"):
            w = widget("", root, key, None, adjustment_step = 0.1)
        elif (key == "antialiasing"):
            w = widget("", root, key, None, stuff)
            w.set_tooltip_text(_("Antialiasing makes on screen text smoother and easier to read"))
            self.widget4 = w
        elif (key == "hinting"):
            w = widget("", root, key, None, stuff)
            w.set_tooltip_text(_("Hinting allows for producing clear, legible text on screen."))
            self.widget5 = w
        elif (key == "font-name"):
            w = widget("", root, key, None)
            self.widget1 = w;
        elif (key == "monospace-font-name"):
            w = widget("", root, key, None)
            self.widget2 = w
        elif (key == "titlebar-font"):
            w = widget("", root, key, None)
            self.widget3 = w
        else:
            w = widget("", root, key, None)

        self.size_groups[1].add_widget(w)
        box.pack_start(w, False, False, 15)
        
        return box
    def restore_button(self):
        box = Gtk.Box(Gtk.Orientation.HORIZONTAL, 0);
        btn = Gtk.Button(_("Retore Default Settings"))
        btn.set_tooltip_text(_("Restore the default font settings for the system. "
                             + "If the system default font is missing, the font will be set to None."))
        btn.connect("clicked", self.restore_button_clicked)
        btn.set_margin_right(20)
        btn.set_margin_bottom(20)
        box.pack_start(btn, False, False, 15)
        btn.set_valign(Gtk.Align.END)
        box.set_halign(Gtk.Align.END)

        return box

    def restore_button_clicked(self, widget):
        # for font name
        if self.widget1:
            font_name = _("Source Han Sans CN Regular 10")
            self.widget1.content_widget.set_font_name(font_name)
            self.widget1.settings.set_string("font-name", font_name)
        if self.widget2:
            font_name = _("WenQuanYi Micro Hei Mono 10")
            self.widget2.content_widget.set_font_name(font_name)
            self.widget2.settings.set_string("monospace-font-name", font_name)
        if self.widget3:
            font_name = _("Source Han Sans CN Regular 11")
            self.widget3.content_widget.set_font_name(font_name)
            self.widget3.settings.set_string("titlebar-font", font_name)

        # for font settings
        if self.widget4:
            self.widget4.content_widget.set_active(2)
            self.widget4.settings.set_string("antialiasing", "rgba")

        if self.widget5:
            self.widget5.content_widget.set_active(1)
            self.widget5.settings.set_string("hinting", "slight")

        return

