#!/usr/bin/env python

from SettingsWidgets import *

class Module:
    def __init__(self, content_box):
        keywords = _("workspace, osd, expo, monitor")
        sidePage = SidePage(_("Workspaces"), "cs-workspaces1", keywords, content_box, module=self)
        self.sidePage = sidePage
        self.name = "workspaces"
        self.category = "prefs"
        self.comment = _("Manage workspace preferences")        

    def shouldLoad(self):
        return True

    def on_module_selected(self):
        if not self.loaded:
            print "Loading Workspaces module"
            bg = SectionBg()        
            self.sidePage.add_widget(bg)
            vbox = Gtk.Box(orientation=Gtk.Orientation.HORIZONTAL)#VERTICAL->HORIZONTAL
            bg.add(vbox)

            section = Section(_("On-Screen Display (OSD)"))  
            section.add(GSettingsCheckButton(_("Enable workspace OSD"), "org.cdos", "workspace-osd-visible", None))
            section.add_indented(GSettingsSpinButton(_("Workspace OSD duration"), "org.cdos", "workspace-osd-duration", "org.cdos/workspace-osd-visible", 0, 2000, 50, 400, _("milliseconds")))
            section.add_indented(GSettingsSpinButton(_("Workspace OSD horizontal position"), "org.cdos", "workspace-osd-x", "org.cdos/workspace-osd-visible", 0, 100, 5, 50, _("percent of the monitor's width")))
            section.add_indented(GSettingsSpinButton(_("Workspace OSD vertical position"), "org.cdos", "workspace-osd-y", "org.cdos/workspace-osd-visible", 0, 100, 5, 50, _("percent of the monitor's height")))
            vbox.add(section)

            vbox.add(Gtk.Separator.new(Gtk.Orientation.HORIZONTAL))  
            
            section = Section(_("Miscellaneous Options"))  
            section.add(GSettingsCheckButton(_("Allow cycling through workspaces"), "org.gnome.mutter", "workspace-cycle", None))
#Only use workspaces on primary monitor (requires Cinnamon restart)
            section.add(GSettingsCheckButton(_("Only use workspaces on primary monitor"), "org.gnome.mutter", "workspaces-only-on-primary", None))
 	    label = Gtk.Label()
            label.set_markup("<i><small>%s</small></i>" % _("requires Cinnamon restart"))
            label.get_style_context().add_class("dim-label")
            section.add(label)
            section.add(GSettingsCheckButton(_("Display Expo view as a grid"), "org.cdos", "workspace-expo-view-as-grid", None))
            vbox.add(section)
